unit uGPIOTemperatur;

// Auslesen, Protokollieren und Chartdarstellung der Temperaturfühler

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, crt, uGlobalVar, Grids, uConfig;


procedure GetTempWerte (var StringGridTemperatur: TStringGrid);



implementation



function parseTemperature(tempStr: string):string;

// Zerlegt Str und ermittelt Temperaturwert

var
  x : integer;   //index used to parse temperature value in a string.
  c : integer;   //temperature reading in celsius.
  f : real;      //temperature value / 1000.

begin
 result := '';

 if tempStr = '' then
 exit;

 x := pos('=', tempStr) + 1;

 begin
   c := strtoint(copy(tempStr,x,5));
   f := c/1000;

   result := floatToStrF(f,ffFixed,2,1);
 end;
end;



procedure GetTempWerte (var StringGridTemperatur: TStringGrid);

// Holt für alle IDs die Ausgaben vom DS18B20

var sl : TStringlist;
    slRows : integer;
    RowPos : integer;
    devFile : string;
    sID : string;
    temp : string;

begin
  sl := TStringlist.Create;

  try
    for RowPos := 1 to  StringGridTemperatur.RowCount-1 do
      begin
        sID := StringGridTemperatur.Cells [1,RowPos];
        devFile := '/sys/bus/w1/devices/' + sID +'/w1_slave';

        (*
        sl.LoadFromFile (IDFile);
        slRows := sl.Count;

        if (slRows = 2) and (pos ('YES', sl [0]) < 0) then
            begin
              temp := sl[1];
              logOutPut := logDateStamp + ',' + sID + ','+ParseTemperature (temp);
            end;
        *)
      end;
  finally
     sl.Free;
  end;
end;



end.

